/*
 *  parseUtilities.cpp
 *  lexical
 *
 *  Created by Chris Harrison on 10/29/05.
 *  Copyright 2005 __MyCompanyName__. All rights reserved.
 *
 */

#include "parseUtilities.h"
#include <string.h>
#include <iostream>



//defines keywords
char * keywords[31] = 
{ 
	"const",
	"case",
	"catch",
	"continue",
	"do",
	"else",
	"elsif",
	"end",
	"then",
	"extends",
	"for",
	"if",
	"private",
	"protected",
	"return",
	"struct",
	"switch",
	"try",
	"while",
	"package",
	"function",
	"procedure",
	"interger",
	"boolean",
	"float",
	"exit",
	"when",
	"type",
	"is",
	"begin",
	".."
};


char symbols[10] = { '.',',',':',';','(',')','[',']','{','}'};


char * operations[18] = { "+","-","*","/","=","!=","<","<=",">",">=",
	"!","&","&&","|","||",":=","+=","**"};



//check if string is a keyword
bool isKeyword(char* s)
{
	bool foundKeyword=false;
	
	for (int i=0; i<31; i++) //iterate through all keywords
	{
		if (strcmp(s,keywords[i])==0) //check to see if there is a match
		{
			foundKeyword=true;
			i=31; //break loop
		}
	}
	
	return foundKeyword;
}

//check if string is a symbol
bool isSymbol(char s)
{
	bool foundSym=false;
	
	for (int i=0; i<10; i++) //iterate through all symbols
	{ 
		if (s == symbols[i]) //check to see if there is a match
		{
			foundSym=true;
			i=10; //break loop
		}
	}
	
	return foundSym;
}

//check if string is a operation
bool isOperation(char* s)
{
	bool foundOp=false;
	
	for (int i=0; i<18; i++) //iterate through all operations
	{
		if (strcmp(s,operations[i])==0) //check to see if there is a match
		{
			foundOp=true;
			i=18; //break loop
		}
	}
	
	return foundOp;
}


//check to see if char c is a letter
bool isLetter(char c)
{
	if ((c>='A' && c<='Z') || (c>='a' && c<='z'))
		return true;
	else
		return false;
}

//check to see if char c is a numeric digit
bool isDigit(char c)
{
	if (c>='0' && c<='9')
		return true;
	else
		return false;
}

//check to see if char c is the end of file character
bool isEOF(char c)
{
	if (c<=0)
		return true;
	else
		return false;
}

//check to see if char c is the end of line character
bool isEndOfLine(char c)
{
	if (c=='\n' || c=='\f')
		return true;
	else
		return false;
}

//check to see if char c is a type of whitespace
bool isWhitespace(char c)
{
	if (c==' ' || c=='\t' || c=='\n' || c=='\f')
		return true;
	else
		return false;
}


//check to see if string s is an integer
bool isInt(char* s)
{
	if (s[0]='-')
		s+=1;

	while (s[0]!=0 && isSymbol(s[0])==false)
	{
		if (isDigit(s[0])==false) //check to see if the character is a numerical digit
			return false; //if it is not, return false
		
		s+=1; //move to next character
	}
	
	return true;  //only numerical digits encountered. String is an interger.  Return true
}


//check to see if string s is an ID
bool isID(char* s)
{
	//prereq: first character has already been determined to be a letter
	
	s++; //advance string pointer past first character
	
	while (s[0]!=0) //continue until end of string
	{
		if (isLetter(s[0])==false && isDigit(s[0])==false && s[0]!='_') 
			return false; //if character is neither a letter, number or underscore, return false
		
		s+=1; //move to next character
	}
	
	return true; 
}


